<?php
namespace Controller;

use Service\Manager\Mongo\Manager;
use Service\DeleteCascadeService;
use Util\Utilities;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class BaseConnections extends Crud {
	protected $dataSourceName = 'baseConnection';
	protected $host;
	protected $port;
	protected $username = 'zmartzeedhi';
	protected $password = 'zmartzeedhi';
	protected $mongoManager;
    protected $mongoDbName;
	
	public function __construct(Manager $mongoManager, DeleteCascadeService $deleteCascadeService, $host, $port, $mongoDbName) {
		parent::__construct($mongoManager, $deleteCascadeService);
		$this->host = $host;
		$this->port = $port;
		$this->mongoManager = $mongoManager;
        $this->mongoDbName = $mongoDbName;
	}
	
	public function setBaseConnectionToImport(DTO\Request\Row $request, DTO\Response $response){
	    $row = $request->getRow();

	    if($row['baseConnections']){
    	    $organizations = explode(',', $row['baseConnections']);
    	    $baseConnections = array();
    	    foreach ($organizations as $org) {
    	        $baseConnection = array(
    	            'host'     => $this->host,
    	            'port'     => $this->port,
    	            'username' => $this->username,
    	            'password' => $this->password,
    	            'dbName'   => $this->mongoDbName.$org,
    	            'dbLabel'  => 'Teknisa'
    	        );
    	        
    	        array_push($baseConnections, $baseConnection);
    	    }

            Utilities::getEnvironment()->setBaseConnection($baseConnections);
	    }
	}
	
	protected function resetCollection(){
	    $filterCriteria = new FilterCriteria($this->dataSourceName);
		$dataSet = $this->mongoManager->findBy($filterCriteria);
		$this->mongoManager->delete($dataSet);
	}
}