<?php

namespace Util;

class Query {

	const GET_OPERADOR_EMAIL = "
		SELECT NMOPERADOR, CDOPERADOR, CDSENHAOPERMD5, DSEMAILOPER
		  FROM OPERADOR
		  WHERE DSEMAILOPER = :DSEMAILOPER 
	";


	const GET_STRUTURE_DAUGHTERS = "
		SELECT E.NRESTRUTURAM, E.NMESTRUTURAM, E.CDINTESTRUTURA
		  FROM ESTRUTURAM E
		  JOIN HIERARQUIAORG H
		    ON E.NRESTRUTURAM = H.NRESTRUTURAMREL 
	     WHERE H.NRESTRUTURAMSUP = :NRESTRUTURAM
	";

	const GET_STRUCTURE_OPERATOR = "

		SELECT DISTINCT E.CDINTESTRUTURA, O.NMORGANIZACAO AS NAME, 'O' AS TYPE,E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
		  FROM ORGANIZACAO O
		  JOIN ESTRUTURAM E ON 'O,NRORG:'||O.NRORG = E.CDINTESTRUTURA
		      LEFT JOIN HIERARQUIAORG H
            ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
              JOIN TIPOESTRUTURA TE
                ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
                  JOIN ESTRUTURAOPER EP
                    ON E.NRESTRUTURAM = EP.NRESTRUTURAMREL
                      JOIN ORGANIZACAOOPER OP
                        ON OP.NRORGANIZACAOOPER = EP.NRORGANIZACAOOPER
		WHERE E.NMESTRUTURAM IS NOT NULL
        AND OP.CDOPERADOR = :CDOPERADOR
		
		UNION

		SELECT E.CDINTESTRUTURA, R.NMAREAGERE AS NAME, 'R' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
					FROM AREAGERE R
					JOIN ESTRUTURAM E ON 'R,CDAREAGERE:'||R.CDAREAGERE = E.CDINTESTRUTURA
					      LEFT JOIN HIERARQUIAORG H
							   ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
								   JOIN TIPOESTRUTURA TE
							  	   ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
		                    JOIN ESTRUTURAOPER EP
		                            ON E.NRESTRUTURAM = EP.NRESTRUTURAMREL
		                              JOIN ORGANIZACAOOPER OP
		                                ON OP.NRORGANIZACAOOPER = EP.NRORGANIZACAOOPER
		        WHERE E.NMESTRUTURAM IS NOT NULL
		        AND OP.CDOPERADOR = :CDOPERADOR
				
		UNION

		SELECT E.CDINTESTRUTURA, C.NMCAIXA AS NAME, 'C' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
						FROM CAIXA C
						JOIN FILIAL F
							ON C.CDFILIAL = F.CDFILIAL
								JOIN ESTRUTURAM E 
								ON 'C,CDFILIAL:'||F.CDFILIAL||',CDCAIXA:'||C.CDCAIXA = E.CDINTESTRUTURA
							      LEFT JOIN HIERARQUIAORG H
									   ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
									    	JOIN TIPOESTRUTURA TE
							  	  		    ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
		                          JOIN ESTRUTURAOPER EP
		                                ON E.NRESTRUTURAM = EP.NRESTRUTURAMREL
		                                  JOIN ORGANIZACAOOPER OP
		                                    ON OP.NRORGANIZACAOOPER = EP.NRORGANIZACAOOPER
		                WHERE E.NMESTRUTURAM IS NOT NULL
		                AND OP.CDOPERADOR = :CDOPERADOR
				
		UNION

		SELECT E.CDINTESTRUTURA, NMLOJA AS NAME, 'L' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
					FROM LOJA L
					JOIN FILIAL F
						ON L.CDFILIAL = F.CDFILIAL
							JOIN ESTRUTURAM E 
								ON 'L,CDFILIAL:'||F.CDFILIAL||',CDLOJA:'||L.CDLOJA = E.CDINTESTRUTURA
							      LEFT JOIN HIERARQUIAORG H
									   ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
									   		JOIN TIPOESTRUTURA TE
							  	   			ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
												JOIN ESTRUTURAOPER EP
													ON E.NRESTRUTURAM = EP.NRESTRUTURAMREL
													  JOIN ORGANIZACAOOPER OP
														ON OP.NRORGANIZACAOOPER = EP.NRORGANIZACAOOPER
						WHERE E.NMESTRUTURAM IS NOT NULL
						AND OP.CDOPERADOR = :CDOPERADOR

		UNION

		SELECT DISTINCT E.CDINTESTRUTURA, S.NMSUPERVISOR AS NAME, 'S' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
					FROM SUPERVISOR S
					JOIN ESTRUTURAM E 
					ON 'S,CDSUPERVISOR:'||S.CDSUPERVISOR = E.CDINTESTRUTURA
						LEFT JOIN HIERARQUIAORG H
								   ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
									   JOIN TIPOESTRUTURA TE
								  	   ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
										 JOIN ESTRUTURAOPER EP
											ON E.NRESTRUTURAM = EP.NRESTRUTURAMREL
											  JOIN ORGANIZACAOOPER OP
												ON OP.NRORGANIZACAOOPER = EP.NRORGANIZACAOOPER
		        WHERE E.NMESTRUTURAM IS NOT NULL
		        AND OP.CDOPERADOR = :CDOPERADOR
				
		UNION

		SELECT E.CDINTESTRUTURA, F.NMFILIAL AS NAME, 'F' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
					FROM FILIAL F
					JOIN ESTRUTURAM E
					ON 'F,CDFILIAL:'||F.CDFILIAL = E.CDINTESTRUTURA
						LEFT JOIN HIERARQUIAORG H
								   ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
									   JOIN TIPOESTRUTURA TE
								  	   ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
											JOIN ESTRUTURAOPER EP
													  ON E.NRESTRUTURAM = EP.NRESTRUTURAMREL
														JOIN ORGANIZACAOOPER OP
														ON OP.NRORGANIZACAOOPER = EP.NRORGANIZACAOOPER
				WHERE E.NMESTRUTURAM IS NOT NULL
				AND OP.CDOPERADOR = :CDOPERADOR
						
		UNION

		SELECT 'Estrutura sem registro' AS CDINTESTRUTURA, 'Estrutura sem registro' AS NAME, 'Estrutura sem tipo' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
		  FROM ESTRUTURAM E
		  LEFT JOIN HIERARQUIAORG H
					   ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
						   JOIN TIPOESTRUTURA TE
								ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
									JOIN ESTRUTURAOPER EP
										ON E.NRESTRUTURAM = EP.NRESTRUTURAMREL
											JOIN ORGANIZACAOOPER OP
												ON OP.NRORGANIZACAOOPER = EP.NRORGANIZACAOOPER
				WHERE E.NMESTRUTURAM IS NOT NULL       
		        AND E.CDINTESTRUTURA IS NULL
		        AND OP.CDOPERADOR = :CDOPERADOR

	";

}
