CREATE OR REPLACE PROCEDURE ARQUIVO_DCTF (
   P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_VERSAO       IN VARCHAR2,
   P_TPDECLARE    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NUMRECANT    IN VARCHAR2,
   P_SITUACAO     IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NATJUR       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_CDCONTADOR   IN NOTAFISCAL.IDSTATUS%TYPE,
   P_BALNCRED     IN NOTAFISCAL.IDSTATUS%TYPE,
   P_DBTOQTA      IN NOTAFISCAL.IDSTATUS%TYPE,
   P_TRIBLUC      IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJINATIVA    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PESJUR       IN VARCHAR2,
   P_JAN          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_FEV          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_MAR          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_ABR          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_MAI          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_JUN          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_JUL          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_AGO          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_SET          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_OUT          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NOV          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_DEZ          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_CRTESCRITUR  IN NOTAFISCAL.IDSTATUS%TYPE,
   P_REGAPUR      IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJBLC        IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJSCP        IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJINDT       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJSEM        IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJMESDCLR    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJCPRB       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_SITUPJ       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_STOPLEI      IN NOTAFISCAL.IDSTATUS%TYPE)
AS
   V_CONTREG_R01_R02_R03     NUMBER;
   V_CONTREGAR10             NUMBER;
   V_CONTREGAR11             NUMBER;
   V_CONTREGAR15             NUMBER;
   V_CONTREGAR20             NUMBER;
   V_CONTREGAR21             NUMBER;
   V_CONTREGAR25             NUMBER;
   V_CONTREGAR30             NUMBER;
   V_CONTREGAR31             NUMBER;
   V_CONTREGAR33            NUMBER;
   V_CONTREGART9             NUMBER;
   V_IRPJ                    VARCHAR2(2);
   V_IRRF                    VARCHAR2(2);
   V_IPI                     VARCHAR2(2);
   V_IOF                     VARCHAR2(2);      
   V_CSLL                    VARCHAR2(2);
   V_PIS                     VARCHAR2(2);
   V_COFINS                  VARCHAR2(2);
   V_CPMF                    VARCHAR2(2);
   V_CIDE                    VARCHAR2(2);
   V_RET                     VARCHAR2(2);
   V_CSRF                    VARCHAR2(2);
   V_COSIRF                  VARCHAR2(2);
   V_CPSSS                   VARCHAR2(2);
BEGIN
   V_IRPJ       := '01';
   V_IRRF       := '02';
   V_IPI        := '03';
   V_IOF        := '04';
   V_CSLL       := '05';
   V_PIS        := '06';
   V_COFINS     := '07';
   V_CPMF       := '08';
   V_CIDE       := '09';
   V_RET        := '10';
   V_CSRF       := '11';
   V_COSIRF     := '12';
   V_CPSSS      := '13';
------------------------------------------------------------------------------------------------------------------------------------------------------------
   /*FICHA - CADASTROS - TIPO HEADER, TIPO R01, TIPO R02*/
   V_CONTREG_R01_R02_R03 := ARQUIVO_DCTF_R01_R02_R03(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_VERSAO,P_TPDECLARE,P_NUMRECANT,
                                                     P_SITUACAO,P_NATJUR,P_CDCONTADOR,P_BALNCRED,P_DBTOQTA,P_TRIBLUC,P_PJINATIVA,P_PESJUR,P_JAN,P_FEV,P_MAR,
                                                     P_ABR ,P_MAI ,P_JUN,P_JUL,P_AGO,P_SET,P_OUT,P_NOV,P_DEZ,P_CRTESCRITUR,P_REGAPUR,P_PJBLC,
                                                     P_PJSCP,P_PJINDT ,P_PJSEM ,P_PJMESDCLR,P_PJCPRB,P_SITUPJ,P_STOPLEI);
------------------------------------------------------------------------------------------------------------------------------------------------------------
   /*FICHA - TRIMESTRE ATUAL*/
------------------------------------------------------------------------------------------------------------------------------------------------------------
   /*TIPO R10 - DBITO APURADO E CRDITOS VINCULADOS*/
   V_CONTREGAR10 := ARQUIVO_DCTF_R10(P_CDEMPRESA,P_CDLIVROMAG,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG ,P_SITUACAO,P_VERSAO,P_BALNCRED,P_DBTOQTA,
                                     V_IRPJ, V_IRRF, V_IPI, V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS);
------------------------------------------------------------------------------------------------------------------------------------------------------------
   /*TIPO R11 - PAGAMENTOS COM DARF*/
   V_CONTREGAR11 := ARQUIVO_DCTF_R11(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,P_DBTOQTA,V_IRPJ,V_IRRF,
                                     V_IPI, V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS);
------------------------------------------------------------------------------------------------------------------------------------------------------------
   /*TIPO R15 - PARCELAMENTO*/
   V_CONTREGAR15 := ARQUIVO_DCTF_R15(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,P_DBTOQTA,V_IRPJ, V_IRRF,
                                     V_IPI, V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS);
------------------------------------------------------------------------------------------------------------------------------------------------------------
   /*FICHA TRIMESTRE ANTERIOR - APENAS CSLL E IRPJ*/
   IF (P_TRIBLUC IN ('0','2','3')) AND (P_DBTOQTA  = '1') THEN
      /*TIPO R20 - DBITO APURADO E CRDITOS VINCULADOS DO TRIMESTRE ANTERIOR*/
      V_CONTREGAR20 := ARQUIVO_DCTF_R20(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,P_BALNCRED,P_DBTOQTA,V_IRPJ,
                                        V_IRRF, V_IPI, V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS);
------------------------------------------------------------------------------------------------------------------------------------------------------------
      /*TIPO R21 - PAGAMENTOS COM DARF*/
      V_CONTREGAR21 := ARQUIVO_DCTF_R21(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,V_IRPJ, V_IRRF, V_IPI,
                                        V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS);
------------------------------------------------------------------------------------------------------------------------------------------------------------
      /*TIPO R25 - PARCELAMENTO*/
      V_CONTREGAR25 := ARQUIVO_DCTF_R25(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,V_IRPJ, V_IRRF, V_IPI,
                                        V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS);
------------------------------------------------------------------------------------------------------------------------------------------------------------
      /*FICHA - QUOTAS*/
      /*TIPO R30 - QUOTAS*/
      V_CONTREGAR30 := ARQUIVO_DCTF_R30(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,V_IRPJ, V_IRRF,
                                        V_IPI, V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS);
------------------------------------------------------------------------------------------------------------------------------------------------------------
      /*TIPO R31 - PAGAMENTOS COM DARF DA QUOTA*/
      V_CONTREGAR31 := ARQUIVO_DCTF_R31(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,V_IRPJ,V_IRRF,
                                        V_IPI, V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS);
------------------------------------------------------------------------------------------------------------------------------------------------------------
      /*TIPO R33 - OUTRAS COMPENSAES DA QUOTA*/
      /*V_CONTREGAR33 := ARQUIVO_DCTF_R33(P_CDLIVROMAG,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,V_IRPJ, V_IRRF,
                                          V_IPI, V_IOF, V_CSLL, V_PIS, V_COFINS, V_CPMF, V_CIDE, V_RET, V_CSRF, V_COSIRF, V_CPSSS); */
   END IF;
------------------------------------------------------------------------------------------------------------------------------------------------------------
   /*TIPO T9 - TRAILLER DA DECLARAO*/
   V_CONTREGART9 := ARQUIVO_DCTF_T9(P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG,P_SITUACAO,V_CONTREG_R01_R02_R03,V_CONTREGAR10,
                                    V_CONTREGAR11,V_CONTREGAR15,V_CONTREGAR20);
------------------------------------------------------------------------------------------------------------------------------------------------------------
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DCTF','5.03.034'); END;
/