import {ChartViewService} from "@/Services/ChartViewService";
import {Utilities} from "@/Services/Utilities";
import { ZmartChartsApex } from "@/Services/Chats/ZmartChartsApex";

export class ChartViewAbstract {
    protected factMaskFunction: any;
    protected dimensionMaskFunction: any;
    protected zmartCharts: any;

    public getSaveViewParams(formExtra: any, values: any, cleanValues: any) {
        const chartSeries = [
            {
                serieColor: [null],
                serieColors: values.serieColors || null,
                serieFields: values.serieFields || null,
                serieLabels: values.serieLabels || null,
                serieLineWidth: values.serieLineWidth || null,
                serieStacked: values.serieStacked || null,
                serieLineType: values.serieLineType || null,
                serieYAxisFormat: values.serieYAxisFormat || null,
                serieType: values.serieType || null
            }

        ];
        cleanValues.chartSeries = chartSeries;
        delete cleanValues.serieColors;
        return cleanValues;
    }
    getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    getZmartCharts() :ZmartChartsApex {
        return <ZmartChartsApex> this.zmartCharts;
    }

    public setDrill(charts :any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
        return charts;
    }

    getEditData(viewData: any) {
        return viewData;
    }
    getCharts(charts: any) {
        return charts;
    }
}
