import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ChartViewService} from "@/Services/ChartViewService";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";

export class Crosstab extends ChartViewAbstract implements ChartViewInterface {
    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if ((dashboard.label !== '' || dashboard.label !== null) && widget[0].children && widget[0].children.length > 0) {
            widget[0].children[0].text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    private setPeriodCompareFormatterFunctionsAndDrill(chart: any) {
        const widget = chart.widget;
        const searchFunction = (_chart: any) => {
            if (_chart.component && _chart.component === "ZdGrid") {
                if (_chart.maskFunction) {
                    _chart.datasource.data.forEach((element: any) => {
                        if (element.value) {
                            element.value = ChartViewService.getMaskFunction(_chart.maskFunction)(parseFloat(element.value));
                        }
                    });
                }
                if (widget.hasDrillDown) {
                    _chart.events = {
                        "rowClick": this.getZmartCharts().drillPeriodCompare.bind(this.getZmartCharts(), widget),
                    };
                }
            }
        };
        searchFunction(chart);
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
        charts[0].events = {
            "cellClick": this.getZmartCharts().drillCrosstab.bind(this.getZmartCharts(), charts[0].widget),
        };
        return charts;
    }
}
